package org.siddhi.api.condition.pattern;


import org.siddhi.api.condition.ExpirableCondition;
import org.siddhi.api.condition.Condition;

public class NonOccurrenceCondition extends ExpirableCondition implements Condition{

    private Condition nonOccurringCondition;
    private Condition followingCondition;
    private FollowedBy followedBy;

    public NonOccurrenceCondition(Condition nonOccurringCondition) {
        this.nonOccurringCondition = nonOccurringCondition;
        followedBy = new FollowedBy(this);
    }


    public Condition getNonOccurringCondition() {
        return nonOccurringCondition;
    }

    public Condition getFollowingCondition() {
        return followingCondition;
    }

    public Condition getOccurringCondition() {
        if(followingCondition instanceof NonOccurrenceCondition){
         return ((NonOccurrenceCondition) followingCondition).getOccurringCondition();
        } else {
        return followingCondition;
        }
    }

    public FollowedBy getFollowedBy() {
        return followedBy;
    }

    public class FollowedBy {
        private NonOccurrenceCondition nonOccurrenceCondition;

        public FollowedBy(NonOccurrenceCondition nonOccurrenceCondition) {
            this.nonOccurrenceCondition = nonOccurrenceCondition;
        }

        public NonOccurrenceCondition followedBy(Condition followedByCondition) {
            followingCondition = followedByCondition;
            return nonOccurrenceCondition;
        }
    }

}
